<?php
// include main config file
include_once("/var/www/zphone/gehrke/etc/config.inc.php");

//DB Connection
$META = $GLOBALS["MSDK"]["SQL"];

$host     = $META["HOST"];
$database = $META["DB"];
$user     = $META["USER"];
$password = $META["PASS"];

do{
  try {
    $con= new PDO("mysql:host=$host;dbname=$database", $user, $password);
  } catch (\Exception $e) {
    print("try to connect to database... ");
  }
  sleep(1);
}while (!$con);
//DB Connection END

$updates	= array();
$null	= NULL;
$tic = time();
if ( array_key_exists("1", $argv ) )
    $looptime = $argv[1];
else
    $looptime = 5;

	// create TCP/IP stream socket
	$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
	// reuseable port
	socket_set_option($socket, SOL_SOCKET, SO_REUSEADDR, 1);
	// bind socket to specified port
	socket_bind($socket, 0, $WS["port"]);
	//listen to socket
	socket_listen($socket);
	// create & add listning socket to the list
	$clients = array($socket);
	// start endless loop, so that our script doesn't stop
	while (true) {
        print(date("Y.m.d H:i:s", time())." start loop\n ");
		// manage multiple connections
		$changed = $clients;
		// returns the socket resources in $changed array
		socket_select($changed, $null, $null, 0, 10);
		// check for new socket
		if ( in_array($socket, $changed) ) {

			print("new connection, client ".$socket."\n");
			// accpet new socket
			$socket_new = socket_accept($socket);
			// add socket to client array
			$clients[] = $socket_new;
			// read data sent by the socket
			$header = socket_read($socket_new, 1024);
			// perform websocket handshake
			perform_handshaking($header, $socket_new, $WS["host"], $WS["port"]);
			// make room for new socket
			$found_socket = array_search($socket, $changed);
			unset($changed[$found_socket]);
			// if updates exist
			if(count($updates) !== 0) {
				// loop through the updates
				foreach($updates as $update) {
					// send update
					@socket_write($socket_new, $update, strlen($update));
				}
			}
		}
		// loop through all connected sockets
		foreach ($changed as $changed_socket) {
			$buf = @socket_read($changed_socket, 1024, PHP_NORMAL_READ);
			// check disconnected client
			if ($buf === false) {
				// remove client for $clients array
				$found_socket = array_search($changed_socket, $clients);
				//socket_getpeername($changed_socket, $ip);
				unset($clients[$found_socket]);
			}
		}
        print(date("Y.m.d H:i:s", time())." checkUpdates\n ");
		    checkUpdates();

        print(date("Y.m.d H:i:s", time())." ant4000_check_data_updates\n ");
        ant4000_check_data_updates();

        print(date("Y.m.d H:i:s", time())." triggerCallRequests\n ");
        triggerCallRequests();


        sleep($looptime);
        print("\n\n");
	}
	// close the listening socket
	socket_close($sock);

  function triggerCallRequests() {

      $DATA = array();
      $DATA_T = array();
      $DATA_T =  mzf_ant4000_calllog_openrequest_get();

      $DATA["action"] = "trigger_callrequests";

      $DATA["data"] = array();
      $DATA["data"] = $DATA_T;
      $DATA["data_call"] = mzf_ant4000_call_data_get();

      send_message(mask(json_encode($DATA)));

      return true;
  }

    function ant4000_check_data_updates() {

        $DATA = array();
	      $DATA_T = array();
	      $DATA_T = mzf_ant4000_dashboard_data_get();
        $DATA["action"] = "update_dashboard";

        $DATA["dash_data"] = array();
        $DATA["dash_data"] = $DATA_T["data"];

	      $DATA["dash_css"]  = array();
	      $DATA["dash_css"] = $DATA_T["css"];

        send_message(mask(json_encode($DATA)));

        return true;

    }

	// check for new Updates
	function checkUpdates() {
		// variables
		global $WS;
		global $updates;
        global $tic;
		// clear updates
		$updates = array();
		// check if file exists
        $tic_diff = time()-$tic;
		if(file_exists($WS["reload_file"]) || $tic_diff > 60 ) {

			print("reload found\n");
            $DATA = array();
            $DATA["action"] = "main_wrapper_reload";
            send_message(mask(json_encode($DATA)));
            if ( file_exists($WS["reload_file"]) )
			    unlink($WS["reload_file"]);
            $tic = time();

		}
	}
	// encode message for transfer to client.
	function mask($text)
	{
		$b1 = 0x80 | (0x1 & 0x0f);
		$length = strlen($text);
		if($length <= 125)
			$header = pack('CC', $b1, $length);
		elseif($length > 125 && $length < 65536)
			$header = pack('CCn', $b1, 126, $length);
		elseif($length >= 65536)
			$header = pack('CCNN', $b1, 127, $length);
		return $header.$text;
	}
	// handshake new client.
	function perform_handshaking($receved_header,$client_conn, $host, $port)
	{
		socket_getpeername($client_conn, $ip);
		$headers = array();
		$lines = preg_split("/\r\n/", $receved_header);
		foreach($lines as $line)
		{
			$line = chop($line);
			if(preg_match('/\A(\S+): (.*)\z/', $line, $matches))
			{
				$headers[$matches[1]] = $matches[2];
			}
		}
		$secKey = $headers['Sec-WebSocket-Key'];
		$secAccept = base64_encode(pack('H*', sha1($secKey . '258EAFA5-E914-47DA-95CA-C5AB0DC85B11')));
		//hand shaking header
		$upgrade  = "HTTP/1.1 101 Web Socket Protocol Handshake\r\n" .
		"Upgrade: websocket\r\n" .
		"Connection: Upgrade\r\n" .
		/*"WebSocket-Origin: $host\r\n" .
		"WebSocket-Location: ws://$host:$port/demo/shout.php\r\n".*/
		"Sec-WebSocket-Accept: $secAccept\r\n\r\n";
		socket_write($client_conn,$upgrade,strlen($upgrade));
	}
	// send message to clients
	function send_message($msg)
	{
		global $clients;
		foreach($clients as $changed_socket)
		{
			@socket_write($changed_socket,$msg,strlen($msg));
		}
		return true;
	}
	// unmask incoming framed message
	function unmask($text) {
		$length = ord($text[1]) & 127;
		if($length == 126) {
			$masks = substr($text, 4, 4);
			$data = substr($text, 8);
		}
		elseif($length == 127) {
			$masks = substr($text, 10, 4);
			$data = substr($text, 14);
		}
		else {
			$masks = substr($text, 2, 4);
			$data = substr($text, 6);
		}
		$text = "";
		for ($i = 0; $i < strlen($data); ++$i) {
			$text .= $data[$i] ^ $masks[$i%4];
		}
		return $text;
	}
?>
