<?php

class SettingsController{

  function showSetupList($ajax = 0 ){
    global $smarty;
    return $smarty->fetch("settinglist.tpl");
  }

  function show_event_maps($ajax = 0 ){
    global $smarty;

    $arr = mzf_ant4000_event_maps_list();
    $smarty->assign("maps", $arr);
    return $smarty->fetch("show_event_maps.tpl");
  }

  function user_list($ajax = 0 ){
    global $smarty;

    $users =  mzf_ant4000_getPersons();
    $smarty->assign("users", $users);

    return $smarty->fetch("user_list.tpl");
  }

  function user_edit($ajax = 0 ){
    global $smarty;

    $user =  mzf_ant4000_getPerson($_POST["args"]["userId"] );

    $smarty->assign("user", $user);

    return $smarty->fetch("user_edit.tpl");
  }

  function user_save($ajax = 0 ){
    global $smarty;

     mzf_ant4000_updateUser($_POST["args"]);

    return $this->user_list(1);
  }

  function user_delete($ajax = 0 ){
    global $smarty;

     mzf_ant4000_deleteUser($_POST["args"]['userId']);

    return $this->user_list(1);
  }


    function user_add($ajax = 0){
      global $smarty;

      return  $smarty->fetch("user_edit.tpl");
    }

  function selftests_list($ajax = 0 ){
    global $smarty;

    $tests =  mzf_ant4000_getSelfTests();

    $smarty->assign("tests", $tests);

    return $smarty->fetch("selftests_list.tpl");
  }

  function selftests_edit($ajax = 0 ){
    global $smarty;

    $test =  mzf_ant4000_getSelfTest($_POST["args"]["selftestId"]);

    $smarty->assign("test", $test);

    return $smarty->fetch("selftest_edit.tpl");
  }

  function selftest_add($ajax = 0 ){
    global $smarty;

    return $smarty->fetch("selftest_edit.tpl");
  }

  function event_map_point_save($ajax = 0 ){
    global $smarty;

    mzf_ant4000_event_maps_points_save( $_POST["args"]);

    unset($_POST["args"]["gemp_id"]);
    return $this->event_map_edit(1);
  }

  function event_map_point_delete($ajax = 0 ){
    global $smarty;

    mzf_ant4000_event_maps_point_del( abs($_POST["args"]["gemp_id"] ));

    unset($_POST["args"]["gemp_id"]);
    return $this->event_map_edit(1);
  }

  function event_map_edit($ajax = 0 ){
    global $smarty;

      $eventMapPointTypeList = mzf_ant4000_event_maps_point_type_list();
      $areas = mzf_ant4000_event_maps_list();

      $GEM = mzf_ant4000_event_maps_get($_POST["args"]["gem_id"]);
      $pointList = mzf_ant4000_event_maps_points_list( $_POST["args"]["gem_id"] );
      $device_types = mzf_ant4000_device_types_list();

      $defaultIcon=$eventMapPointTypeList[key($eventMapPointTypeList)];

      $smarty->assign("defaultIcon", $defaultIcon);
      $smarty->assign("device_types", $device_types);
      $smarty->assign("areas", $areas);
      $smarty->assign("GEM", $GEM);
      $smarty->assign("pointList", $pointList);
      $smarty->assign("gem_id", $_POST["args"]["gem_id"]);
      $smarty->assign("eventMapPointTypeList", $eventMapPointTypeList);

      if(isset($_POST["args"]["gemp_id"]) && $_POST["args"]["gemp_id"]!==0){

        if ( $_POST["args"]["gemp_id"] == -1 ) {
            $gemp_arr = array();
            $gemp_arr["gemp_gem_id"] = $_POST["args"]["gem_id"];
            $gemp_arr["gemp_width"] = 25;
        } else {
            $gemp_arr = mzf_ant4000_event_maps_points_get( $_POST["args"]["gemp_id"] );
        }

        $smarty->assign("gemp_arr", $gemp_arr);
        $smarty->assign("gemp_id", $_POST["args"]["gemp_id"]);
        $smarty->assign("editmode", 1);

      }else{

        $smarty->assign("editmode", 0);

      }

      return $smarty->fetch("event_map_edit.tpl");
  }

  function event_map_del($ajax = 0 ){
    global $smarty;

    mzf_ant4000_event_maps_del( $_POST["args"]["gem_id"] );
    $_GET["action"] = "show_event_maps";

    return $this->show_event_maps(1);
  }

  function event_map_add($ajax = 0 ){
    global $smarty;

    $picList = mzf_ant4000_event_maps_pic_list();

    $smarty->assign("picList", $picList);

    return $smarty->fetch("event_map_add.tpl");
  }

  function event_map_save($ajax = 0 ){
    global $smarty;

    mzf_ant4000_event_maps_save( $_POST["args"] );

    return $this->show_event_maps();
  }

  function selftest_save($ajax = 0 ){
    global $smarty;

     mzf_ant4000_updateSelftest($_POST['args']);

    return $this->selftests_list();
  }


  function selftest_delete($ajax = 0 ){
    global $smarty;

     mzf_ant4000_deleteSelftest($_POST['args']['selfTestId']);

    return $this->selftests_list();
  }

  function callrequest_reset($ajax = 0 ){

    mzf_ant4000_callrequest_reset();

    return $this->showSetupList($ajax);
  }

  function ant4000_selftest_configs($ajax = 0 ){
	global $smarty;

	$setup = zphone_ant4000_setup_get();
	$tests = zphone_ant4000_reports_list();

    $smarty->assign("setup", $setup);
	$smarty->assign("tests", $tests);

    return $smarty->fetch("selftest_configs.tpl");
  }

  function ant4000_selftest_configs_setup_save($ajax = 0 ){
	global $smarty;

	zphone_ant4000_setup_save($_POST["args"]);

    return $this->ant4000_selftest_configs();
  }

  function ant4000_selftest_configs_setup_edit($ajax = 0 ){
	global $smarty;

	if(isset($_POST["args"])){

		if($_POST["args"]["a4r_id"]){
			$test = zphone_ant4000_reports_get($_POST["args"]["a4r_id"]);
			$smarty->assign("test", $test);
		}

	}

    return $smarty->fetch("selftest_configs_edit.tpl");
  }

  function ant4000_selftest_configs_setup_edit_save($ajax = 0 ){
  	global $smarty;

  	zphone_ant4000_reports_save($_POST["args"]);

    return $this->ant4000_selftest_configs();
  }

  function ant4000_selftest_configs_setup_delete($ajax = 0 ){
	global $smarty;

	zphone_ant4000_reports_del($_POST["args"]["a4r_id"]);

    return $this->ant4000_selftest_configs();
  }



} ?>
