<?php

function mzf_ant9000_get_device_status($uid){
  syslog(LOG_INFO, $uid);
  $ext = mzf_ant9000_get_host_ext($uid);
  $ip = mzf_ant9000_get_ip_by_ext($ext);

  $command_id = time();

  mzf_ant9000_send_to_socket($ip, "C${id}S");
  $data = @mzf_ant9000_wait_for_socket_answer($command_id);

  syslog(LOG_INFO,$data);

  return $data;
}

function mzf_ant9000_get_device_type($dest){
  $s = new SQL;
  $GEM = array();

  $s->query("SELECT dt_name FROM
    ant4000_device_types, ant4000_event_maps_points WHERE ant4000_device_types.dt_id = ant4000_event_maps_points.gemp_device_type AND ant4000_event_maps_points.gemp_ext=$dest");
  $s->next_record();
  $GEM = $s->msdk_get_sql_arr();

  $s->free_result();

  return $GEM["dt_name"];
}

function mzf_ant4000_cancle_call($ext,$from){
  global $ACTUALCALL;

  syslog(LOG_INFO,"sdf");

  if(file_exists($ACTUALCALL)){
    $data = file_get_contents($ACTUALCALL);
    $data = explode("|", $data);

    if (trim($data[0]) == $ext ) {
      mzf_ant4000_unlink_call();
      exit;
    }
  }else{
    syslog(LOG_INFO,$ACTUALCALL." file not exists ");
  }
}

function mzf_ant9000_get_host_ext($from){

  $user = mzf_ant4000_getPerson($from);
  return $user["pe_ext"];
}

function mzf_ant9000_reports_exec($ext, $calibrations){

  if(mzf_ant9000_test_ext($ext, $calibrations)){
    zphone_ant4000_reports_log_write($ext, "OK" );
  }else{
    zphone_ant4000_reports_log_write($ext, "NOK" );
	exec($calibrations['a4r_failure_event']." ".$ext);
  }

}
function mzf_ant9000_call($userID, $ext){

  $hostExt = mzf_ant9000_get_host_ext($userID);
  $ip = mzf_ant9000_get_ip_by_ext($hostExt);
  syslog(LOG_INFO,"test ". $ip);
  $command_id = time();

  mzf_ant9000_send_to_socket("$ip", "C${command_id}E${ext}");
  mzf_ant9000_send_to_socket("$ip", "C${command_id}KR");
}

function mzf_ant9000_end_call($from){

  $hostExt = mzf_ant9000_get_host_ext($from);
  $ip = mzf_ant9000_get_ip_by_ext($hostExt);
  $command_id = time();

  mzf_ant9000_send_to_socket("$ip", "C${command_id}KC");
  mzf_ant9000_send_to_socket("$ip", "C${command_id}KR");
  
  mzf_ant9000_send_to_socket("$ip", "C${command_id}E");
  mzf_ant9000_send_to_socket("$ip", "C${command_id}KR");

}

function mzf_ant9000_test_ext($ext, $calibrations){

  $ip = mzf_ant9000_get_ip_by_ext($ext);
  $command_id = time();

  mzf_ant9000_send_to_socket($ip, "C${command_id}C".$calibrations['signal'].";".$calibrations['mic']);

  $data = @mzf_ant9000_wait_for_socket_answer($command_id);

  if($data){

    $data = explode ("|", $data)[0];
    $strlen = strlen($data);

	syslog(LOG_INFO,$data." rec ");

    if($data[$strlen-1] == 1){
        return true;
    }else{
        return false;
    }
  }

  return false;
}

function mzf_ant9000_send_to_socket($ip, $msg, $port=18225){
  if(empty($ip)){
    return;
  }
  $sock = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
  $len=strlen($msg);
  socket_sendto($sock, $msg, $len, 0, $ip, $port);
  socket_close($sock);
}


function mzf_ant9000_wait_for_socket_answer($command_id){

  $i = 0;

  while(1){
	  
    if($i++ == 100) {
      syslog(LOG_INFO,"NO ANSWERE FROM $command_id");
      return "";
    }
	
    usleep(10000);
    syslog(LOG_INFO,"wait for $command_id");
    @$shm_id = shmop_open($command_id, "a", 0666, 1000);
    if ($shm_id) {
      $data =  shmop_read($shm_id, 0, 100);
      shmop_delete($shm_id);
      return $data;
    }
  }
}

function mzf_ant9000_get_ip_by_ext($ext){
  $id = time();

  syslog(LOG_INFO,"$id\n");

  mzf_ant9000_send_to_socket('224.0.1.11', "C${id}D${ext}");
  $data = mzf_ant9000_wait_for_socket_answer($id);

  if($data){
    $tmp = explode ("|", $data);
    return $tmp[1];
  }

  return $data;
}



?>
