<?php
/*
*	(�) by Lukas Ziaja <lz@stylemaster.de>
*
*	SQL functions - CORE
*
*	Enable needed php-modules
*
*	Some php-installations are compiled without builtin mysql-support.
*	so u have to check and load the module
*
*/

function mktimeold($hour, $minute, $second, $month, $day, $year)
{
	if($month!=0 && $day!=0 && $year != 0)
		return mktime($hour, $minute, $second, $month, $day, $year);
	else return -1;
}


CLASS SQL {

	var $Host;
	var $Database;
	var $User;
	var $Password;

	var $PDO;
	var $statement;
	var $Record;            /* alle ergebnisse aus dem query */
	var $Row;               /* aktuelle spalte aus dem ergebnissen */

	var $Errno;
	var $Error;

	var $Auto_free;         /* Set this to 1 for automatic mysql_free_result() */
	var $Auto_commit;       /* set this to 1 to automatically commit results */

	function SQL() {
		$META = $GLOBALS["MSDK"]["SQL"];

		$this->Host     = $META["HOST"];
		$this->Database = $META["DB"];
		$this->User     = $META["USER"];
		$this->Password = $META["PASS"];

		$this->Row;

		$this->Errno    = 0;
		$this->Error    = "";

		$this->Auto_free   = 0;   /* Set this to 1 for automatic mysql_free_result() */
		$this->Auto_commit = 0;   /* set this to 1 to automatically commit results */
	} /* Ende Constructor DBbase_Sql */


	function connect() {

		if ( !$this->PDO ) {

			$this->PDO = new PDO("mysql:host=$this->Host;dbname=$this->Database", $this->User, $this->Password);


			if (!$this->PDO) {
        			$this->halt("PDO == false, connect failed");
			}
		}
	}

	function query($Query_String) {

		$this->PDO = new PDO("mysql:host=$this->Host;dbname=$this->Database", $this->User, $this->Password);

		$this->statement = $this->PDO->query($Query_String);

		$this->Row   = 0;

		if (!$this->statement) {
			$this->halt("Invalid SQL: ".$Query_String);
		}

		return $this->statement;
	} /* Ende function query() */


	function next_record() {

		$this->Record = $this->statement->fetch();

		$this->Row   += 1;

		$stat = is_array($this->Record);

		return $stat;
	} /* Ende function next_record() */


	function affected_rows() {
		return  $this->statement->rowCount();
	}

	function num_rows() {
		return $this->statement->rowCount();
	}

	function num_fields() {
		return $this->statement->columnCount ();
	}

	function f($Name) {
		return $this->Record[$Name];
	}

	function g($Name, $new_val) {
		$this->Record[$Name] = $new_val;
	}

	function p($Name) {
		print $this->Record[$Name];
	}

	function halt($msg) {
		printf("<b>Database error:</b> %s<br>\n", $msg);
		printf("<b>MySQL Error</b>: %s (%s)<br>\n", $this->Errno, $this->Error);
		die("Session halted.<br>In file: <b>".$GLOBALS[SCRIPT_NAME]);
  	}

	function free_result() {
		return 1;
	}

	function insert_id() {
		return $this->PDO->lastInsertId();
	}

    function sql_get_result() {
		return $this->ResultArray;
    }

	function msdk_get_sql_arr() {

		$data = array();

		if ( !is_array( $this->Record ) )
			return $data;

		foreach ( $this->Record as $key => $val ) {
		if ( !is_int($key) )
			$data[$key] = trim($val);
		}

		if ( func_num_args() > 0 )
			$this->free_result();

		return $data;
	}

	function msdk_create_sql_query($DATA, $fields, $type ) {

		$query = array();

		if ( !is_array($DATA) )
			return FALSE;

		if ( !is_array( $fields ) ) {
			$fields = explode("," , $fields );
		}

		if ( $type == "u" ) {
			foreach ( $fields as $col ) {
				if ( is_int($DATA[$col]) )
					$query[] = " $col=$DATA[$col] ";
				else
					$query[] = " $col='$DATA[$col]' ";
			}
		} elseif ( $type == "i" ) {

			foreach ( $fields as $col ) {
				if ( is_int($DATA[$col]) )
					$query[] = $DATA[$col];
				else
					$query[] = " '$DATA[$col]' ";
			}

		}

		if ( $type == "i" )
			return " ( ".implode(",", $fields )." ) VALUES (".implode(",", $query )." ) ";

		elseif ( $type == "u" )
			return implode( ",", $query );

	}


} /* Ende CLASS SQL */



?>
