<?php

//ini_set('display_errors', 1);
//ini_set('display_startup_errors', 1);
//error_reporting(E_ALL);

date_default_timezone_set('Europe/Berlin');

header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Datum in der Vergangenheit

require_once("model/LoginModel.php");
include("etc/config.inc.php");

require_once('controllers/SettingsController.php');
require_once('controllers/LoginController.php');
require_once('controllers/AreaController.php');
require_once('controllers/ReportController.php');
require_once('controllers/SelftestController.php');
require_once('controllers/DashboardController.php');
require_once('controllers/LogExportController.php');
require_once('controllers/PhonebookController.php');
require_once('controllers/FileController.php');

require_once("etc/smartyConf.inc.php");

$loginController = new LoginController();

$dashboardController = new DashboardController();
$areaController = new AreaController();
$reportController = new ReportController();
$selftestController = new SelftestController();
$settingsController = new SettingsController();
$logExportController = new LogExportController();
$phonebookController = new PhonebookController();
$fileController = new FileController();

$actionMap = array();

$actionMap['login']            =   array("class" => $loginController,     "method" => "login");
$actionMap['showLogin']        =   array("class" => $loginController,     "method" => "showLogin");
$actionMap['dashboard']        =   array("class" => $dashboardController, "method" => "showDashboard");
$actionMap['main']             =   array("class" => $dashboardController, "method" => "showDashboard");
$actionMap['areas']            =   array("class" => $areaController,      "method" => "showAreas");
$actionMap['reports']          =   array("class" => $reportController,    "method" => "showReports");
$actionMap['selftests']        = array("class" => $selftestController,    "method" => "showSelftests");

$actionMap['setup']            =    array("class" => $settingsController, "method" => "showSetupList");

$actionMap['show_event_maps']  =   array("class" => $settingsController, "method" => "show_event_maps");

$actionMap['selftests_list']   =   array("class" => $settingsController, "method" => "selftests_list");
$actionMap['selftest_save']    =   array("class" => $settingsController, "method" => "selftest_save");
$actionMap['selftests_edit']   =   array("class" => $settingsController, "method" => "selftests_edit");
$actionMap['selftest_add']     =   array("class" => $settingsController, "method" => "selftest_add");
$actionMap['selftest_delete']  =   array("class" => $settingsController, "method" => "selftest_delete");

$actionMap['user_list']               =   array("class" => $settingsController, "method" => "user_list");
$actionMap['user_edit']               =   array("class" => $settingsController, "method" => "user_edit");
$actionMap['user_save']               =   array("class" => $settingsController, "method" => "user_save");
$actionMap['user_delete']             =   array("class" => $settingsController, "method" => "user_delete");
$actionMap['user_add']                =   array("class" => $settingsController, "method" => "user_add");

$actionMap['event_map_edit']          =   array("class" => $settingsController, "method" => "event_map_edit");
$actionMap['event_map_point_save']    =   array("class" => $settingsController, "method" => "event_map_point_save");
$actionMap['event_map_point_delete']  =   array("class" => $settingsController, "method" => "event_map_point_delete");

$actionMap['event_map_del']           =   array("class" => $settingsController, "method" => "event_map_del");
$actionMap['event_map_add']           =   array("class" => $settingsController, "method" => "event_map_add");
$actionMap['event_map_save']          =   array("class" => $settingsController, "method" => "event_map_save");
$actionMap['callrequest_reset']       =   array("class" => $settingsController,   "method" => "callrequest_reset");

$actionMap['ant4000_selftest_configs']       =   array("class" => $settingsController,   "method" => "ant4000_selftest_configs");
$actionMap['ant4000_selftest_configs_setup_save']       =   array("class" => $settingsController,   "method" => "ant4000_selftest_configs_setup_save");
$actionMap['ant4000_selftest_configs_setup_edit']       =   array("class" => $settingsController,   "method" => "ant4000_selftest_configs_setup_edit");
$actionMap['ant4000_selftest_configs_setup_edit_save']       =   array("class" => $settingsController,   "method" => "ant4000_selftest_configs_setup_edit_save");
$actionMap['ant4000_selftest_configs_setup_delete']       =   array("class" => $settingsController,   "method" => "ant4000_selftest_configs_setup_delete");


$actionMap['loadImg']                 =   array("class" => $areaController,      "method" => "loadImg");
$actionMap['loadByExt']               =   array("class" => $areaController,      "method" => "loadByExt");
$actionMap['call']                    =   array("class" => $areaController,      "method" => "call");
$actionMap['call_end']                =   array("class" => $areaController,     "method" => "call_end");

$actionMap['reportFilter']           =   array("class" => $reportController,    "method" => "reportFilter");
$actionMap['reportExport']           =   array("class" => $reportController,    "method" => "reportExport");
$actionMap['downloadReport']         =   array("class" => $reportController,    "method" => "downloadReport");
$actionMap['report_sort']            =   array("class" => $reportController,     "method" => "report_sort");
$actionMap['report_filtered_sort']   =   array("class" => $reportController,     "method" => "report_filtered_sort");

$actionMap['logexport']               =   array("class" => $logExportController,   "method" => "showLogexporter");
$actionMap['logFilter']               =   array("class" => $logExportController,   "method" => "logFilter");
$actionMap['logExport']               =   array("class" => $logExportController,   "method" => "logExport");
$actionMap['generallog_sort']         =   array("class" => $logExportController,   "method" => "generallog_sort");
$actionMap['calllog_sort']            =   array("class" => $logExportController,   "method" => "calllog_sort");

$actionMap['phonebook']             =   array("class" => $phonebookController,   "method" => "show");
$actionMap['phonebook_edit']        =   array("class" => $phonebookController,   "method" => "phonebook_edit");
$actionMap['phonebook_delete']        =   array("class" => $phonebookController,   "method" => "phonebook_delete");
$actionMap['phonebook_add']        =   array("class" => $phonebookController,   "method" => "phonebook_add");
$actionMap['phonebook_save']        =   array("class" => $phonebookController,   "method" => "phonebook_save");

$actionMap['icon_list']        =   array("class" => $fileController,   "method" => "icon_list");
$actionMap['icon_delete']        =   array("class" => $fileController,   "method" => "icon_delete");
$actionMap['icon_add']        =   array("class" => $fileController,   "method" => "icon_add");

$actionMap['map_list']        =   array("class" => $fileController,   "method" => "map_list");
$actionMap['map_delete']        =   array("class" => $fileController,   "method" => "map_delete");
$actionMap['map_add']        =   array("class" => $fileController,   "method" => "map_add");

if(empty($_POST)){
  $data = $_GET;
}else{
  $data = $_POST;
}

if(isset($data['action'])){

  $action = $data['action'];

}else{
  $action = "default";
}

if(isset($data['ajax'])){
  $smarty->assign("ajax", true);
}else{
  $smarty->assign("ajax", false);
}

if($action == "login"){

  $model = $loginController->login($_POST['AUTH']);
  $data['sid'] = $model->SID;
  $data['uid'] = $model->uid;

  $action ="default";

}

if(!(isset($data['sid']) && isset($data['uid'])) ){
  $content = $loginController->showLogin();
}else{
  $sid= $data['sid'];
  $uid= $data['uid'];

  $valid = $loginController->checkLogin($sid,$uid);

  if(!$valid){
    $content = $loginController->showLogin();
  }else{
    $level = $loginController->getLevel($uid);
    $smarty->assign("level", $level);
  }

}

if($action == "logout"){

  $loginController->logout($data['uid']);

  unset($sid);
  unset($uid);
  unset($_POST);
  unset($_GET);

  $content = $loginController->showLogin();
  print($content);
  return;
}

if(isset($data['sid']) && isset($data['uid'])){

    $sid= $data['sid'];
    $uid= $data['uid'];

    $valid = $loginController->checkLogin($sid, $uid);

    if(!$valid){
      $content = $loginController->showLogin();
      print($content);
      return;
    }

  }else{
    $content = $loginController->showLogin();
    print($content);
    return;
  }

  if($action === "default"){

    if($level < 2){
      $action="dashboard";
    }else if($level == 2){
      $action="areas";
    }else if($level == 3){
      $action="phonebook";
    }
  }

  $go = array($actionMap[$action]["class"],
              $actionMap[$action]["method"]);


  $smarty->assign("sid", $sid);
  $smarty->assign("uid", $uid);

  $content = call_user_func_array($go, $data);

print($content);
