(
	function()
	{
		var	macpDashboardUpdater,
			macpWebSocket

		macpDashboardUpdater =
		{
			update: function(oData, sType)
			{
				Object.keys(oData).forEach
				(
					function(sKey)
					{
						var eElement

						eElement = document.querySelector("#" + sKey)
						if(eElement !== null)
						{
							switch(sType)
							{
								case "css":
									eElement.setAttribute("style", oData[sKey])
									break
								case "data":
									eElement.innerHTML = oData[sKey]
									break
							}
						}
					}.bind(this)
				)
			}
		}
		macpWebSocket =
		{
			oWebSocket: null,

			onConnected: function()
			{
			},
			onDisconnected: function()
			{
				this.initialize()
			},
			onError: function()
			{
			    //alert('on error event');
			    document.getElementById('stat_ws').style.backgroundColor='red;';
			},
			onMessage: function(sMessage)
			{
				var oData

				oData = JSON.parse(sMessage.data)
				switch(oData.action)
				{
					case "main_wrapper_reload":
						macp_main_wrapper_reload()
						break
					case "reload":
						this.oWebSocket.close()
						window.location.reload(true)
						break
					case "update_dashboard":
						macpDashboardUpdater.update(oData.dash_data, "data")
						if(typeof oData.dash_css === "object")
						{
							macpDashboardUpdater.update(oData.dash_css, "css")
						}
						break
				}
			},

			initialize: function()
			{
				this.oWebSocket = new WebSocket("ws://<?php print($WS["host"].":".$WS["port"]); ?>")
				this.oWebSocket.onopen	= this.onConnected.bind(this)
				this.oWebSocket.onerror	= this.onError.bind(this)
				this.oWebSocket.onmessage	= this.onMessage.bind(this)
				this.oWebSocket.onclose	= this.onDisconnected.bind(this)

				return this
			}
		}

		document.addEventListener("DOMContentLoaded", function(){macpWebSocket.initialize()})
	}()
)
